class Boxes {

  int _boxesOnX, _boxesOnY, _amountLedsX, _amountLedsY;
  float _boxWidth, _boxHeight; 
  Box[] _ledBox;

  Boxes(int boxesOnX, int boxesOnY, int amountLedsX, int amountLedsY) {
    _boxesOnX = boxesOnX;
    _boxesOnY = boxesOnY; 

    _amountLedsX = amountLedsX;
    _amountLedsY = amountLedsY;
    _ledBox = new Box[_amountLedsX*_amountLedsY];

    init();
  }

  Box getBox(int number) {
    return  _ledBox[number];
  }
 
  Box[] getAllBoxes() {
    return  _ledBox;
  }

  void init() {

    int counterBoxes = 0;
    float ledDiameter = calcLedDiameter();
    for (int x = 0; x < _boxesOnX; x++) { //0
      for (int y = 0; y< _boxesOnY; y++) { //0,1,2,3
        float posX = x * _boxWidth;
        float posY = y * _boxHeight;
        _ledBox[counterBoxes] = new Box(counterBoxes, _amountLedsX, _amountLedsY, posX, posY, ledDiameter);
        counterBoxes++;
      }
    }
  }

  float calcLedDiameter() {

    float ledDiameterHeight = height/ (_boxesOnY * _amountLedsY);
    float ledDiameterWidth = width/ (_boxesOnX * _amountLedsX);
    float ledDiameter = min(ledDiameterHeight, ledDiameterWidth);
    _boxWidth = ledDiameter*_amountLedsX;
    _boxHeight = ledDiameter*_amountLedsY;

    return ledDiameter;
  }
}
